/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO SG90 servo steering robot car Lesson 2
 * Tutorial URL https://osoyoo.com/?p=37134
 * CopyRight www.osoyoo.com

 *   
 * 
 */
#include <Servo.h>
#define IN3 9
#define IN4 10
#define ENB 6        //  ENB pin
 
 
#define FRONT 90        // steering to front 
int SHARP_RIGHT=FRONT+33;
int SHARP_LEFT=FRONT-40;

#define DELAY_TIME 1200     
#define BACK_TIME 1000  
#define SPEED 190
#define HI_SPEED 220
#define SERVO_PIN 7  //servo connect to D7
 
Servo head;
/*motor control*/
void go_Advance(int speed)  //Forward
{
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4,LOW); 
  analogWrite(ENB,speed);
}
 
void go_Back(int speed)  //Forward
{
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,HIGH); 
  analogWrite(ENB,speed);
 
}
 
void turn(int angle)
{

  head.write(angle);

}
 
void stop_Stop()    //Stop
{
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,LOW);
  analogWrite(ENB,0);
 
}

  
void setup() {

 pinMode(ENB, OUTPUT); 
 pinMode(IN3, OUTPUT); 
 pinMode(IN4, OUTPUT); 


head.attach(SERVO_PIN);
 turn(FRONT);
 go_Advance(SPEED);
 delay(DELAY_TIME); 
 
 go_Back(SPEED);
 delay(DELAY_TIME);

 go_Advance(HI_SPEED);
 turn(SHARP_LEFT);
 delay(DELAY_TIME);

 turn(SHARP_RIGHT);
 delay(DELAY_TIME);
stop_Stop();//stop move
delay(100);
 turn(FRONT);
 go_Back(HI_SPEED);
 delay(BACK_TIME);
 turn(SHARP_RIGHT);
  delay(BACK_TIME);
 turn(SHARP_LEFT);

delay(BACK_TIME);

turn(FRONT);
stop_Stop();//stop move
 // Serial.begin(9600);

}

 
void loop() {
 
}
